/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef DISPLAY_H
#define DISPLAY_H

#include "Widget.h"
#include "Window.h"

namespace SharpConstruct
{
	namespace Interface
	{
		class Display
		{
		public:				
			virtual ~Display()
			{}
		
			virtual void Draw() = 0;
			virtual void Postwork() = 0;
		
			virtual void Run() = 0;
			virtual void DoEvents() = 0;
		
			virtual void Close() = 0;
				
			virtual int W() const = 0;
			virtual int H() const = 0;
			virtual void SetSize( const int w, const int h ) = 0;

			virtual void SetCursor( Widget::Cursors c ) = 0;
		};
	}
}
	
#endif // DISPLAY_H
