/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef DIVIDER_H
#define DIVIDER_H

#include "Widget.h"

namespace SharpConstruct
{
	namespace Interface
	{		
		class VerticalDivider : public Widget
		{
		public:
			VerticalDivider( int x, int y, int w, int h )
			: Widget( x, y, w, h, "DIVIDER" )
			{
				MouseMoveSignal.connect( sigc::mem_fun( *this, &VerticalDivider::_mouse_move ) );
				SetCursor( HORIZ_ARROWS );
			}
			
			void SetBounds( int l, int r )
			{
				_left_bound = l;
				_right_bound = r;
			}
			
			sigc::signal< void > ResizeSignal;
		protected:
			virtual void _draw();
		private:
			void _mouse_move();
		
			int _left_bound, _right_bound;
		};
	}
}

#endif // DIVIDER_H
