/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef INPUTDIALOG_H
#define INPUTDIALOG_H

#include "Dialog.h"
#include "TextEntry.h"
#include <vector>

namespace SharpConstruct
{
	namespace Interface
	{
		class InputDialogs;
		
		class InputDialog : public Dialog
		{
		public:
 			InputDialog( const std::string& lbl,
			             const std::vector< std::string >& button_labels );
		
			virtual ~InputDialog()
			{}
			
			std::vector< Button >& GetButtons()
			{
				return _buttons;
			}
			
			static std::string ModalInput( Group& p, const std::string& lbl,
			                               const std::string& b1,
			                               const std::string& b2 );
		protected:
			virtual void _draw();
		private:
			void _button_catcher();
		
			std::string _selected_button;
			TextEntry _dir;
			HorizontalGroup _controls;
			std::vector< Button > _buttons;
		};
	}
}
#endif // INPUTDIALOG_H
