/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef LIST_H
#define LIST_H

#include <vector>

namespace SharpConstruct
{
	template< typename T > class List
	{
	public:
		typedef typename std::list< T >::iterator Iterator;

		virtual ~List()
		{}
		/*virtual ~List()
		{
			for( Iterator i = Begin(); i != End(); i++ )
				delete ( *i );
		}*/
		
		Iterator Begin()
		{
			return _t.begin();
		}
		Iterator End()
		{
			return _t.end();
		}
		T& Back()
		{
			return _t.back();
		}
		T& Front()
		{
			return _t.front();
		}
		virtual void PushFront( const T& t )
		{
			_t.push_front( t );
		}
		virtual void PushFront( T& t )
		{
			_t.push_front( t );
		}
		virtual void PushBack( const T& t )
		{
			_t.push_back( t );
		}
		virtual void PushBack( T& t )
		{
			_t.push_back( t );
		}
		unsigned Size() const
		{
			return _t.size();
		}
		void Clear()
		{
			_t.clear();
		}
		Iterator Find( T t )
		{
			return find( Begin(), End(), t );
		}
		virtual void Erase( Iterator i )
		{
			_t.erase( i );
		}
	private:
		std::list< T > _t;
	};
}

#endif // LIST_H
