/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef LISTBOX_H
#define LISTBOX_H

#include "Group.h"
#include "Scrollbar.h"
#include <string>
#include <vector>

namespace SharpConstruct
{
	namespace Interface
	{
		class ListBox : public Group, public std::vector< std::string >
		{
		public:
			ListBox( int x, int y, int w, int h );
				
			virtual ~ListBox()
			{}
				
			void MakeInactive();
				
			void Refresh();
				
			void push_back( const std::string );
				
			std::string Selection() const;
				
			sigc::signal< void, std::string > SelectSignal;
		protected:
			virtual void _draw();
		private:
			void _mouse_select();
			void _mouse_up();
		
			const unsigned _ELEMENT_HEIGHT;
		
			VerticalScrollbar _bar;
			int _selected;
		};
	}
}
#endif // LISTBOX_H
