/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#ifndef SETTINGSDIALOG_H
#define SETTINGSDIALOG_H

#include "Button.h"
#include "ColorPicker.h"
#include "Dialog.h"
#include "Infobar.h"
#include "Slider.h"

namespace SharpConstruct
{
	namespace Interface
	{
		class MainWindow;
		
		class SettingsDialog : public Dialog
		{
		public:
			SettingsDialog( MainWindow& mw );
				
			virtual ~SettingsDialog()
			{}
				
			virtual void Show();
		private:
			void _reset_color();
			void _save_settings();
		
			MainWindow& _parent;
			VerticalGroup _bg_group;
			Infobar _bg_label;
			Button _bg_reset;
			ColorPicker _bg_color;
			Slider _history_steps;
			Button _save;
		};
	}
}
#endif // SETTINGSDIALOG_H
