/* Copyright 2004, 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "../include/Color.h"

#include <iostream>

using namespace SharpConstruct;

Color::Color()
: Red( 1 ), Green( 1 ), Blue( 1 )
{}

Color::Color( float r, float g, float b )
: Red( r ), Green( g ), Blue( b )
{}
	
Color::~Color()
{}
	
bool Color::IsGrey() const
{
	return Red == Green && Green == Blue;
}

void Color::SetToBlack()
{
	Red = 0;
	Green = 0;
	Blue = 0;
}
