/* Copyright 2004, 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "../include/ColorMask.h"

ColorMask::ColorMask()
: _mask_intensity( 0 )
{}

ColorMask::~ColorMask()
{}

float ColorMask::Red()
{
	return C.Red + _mask_intensity;
}

void ColorMask::Red( float R )
{
	C.Red = R - _mask_intensity;
}

float ColorMask::Green()
{
	return C.Green + _mask_intensity;
}

void ColorMask::Green( float G )
{
	C.Green = G - _mask_intensity;
}

float ColorMask::Blue()
{
	return C.Blue + _mask_intensity;
}

void ColorMask::Blue( float B )
{
	C.Blue = B - _mask_intensity;
}

float ColorMask::MaskIntensity()
{
	return _mask_intensity;
}

void ColorMask::MaskIntensity( float intensity )
{
	_mask_intensity = intensity;
	
	C.Red -= _mask_intensity;
	C.Green -= _mask_intensity;
	C.Blue -= _mask_intensity;
}
