#include "Group.h"
#include <GL/gl.h>

#include <iostream>

using namespace SharpConstruct::Interface;

void Group::MouseDown()
{
	if( Visible() && Enabled() &&
	    ( Contains( Event::Mouse.Location ) || !Corporeal() ) )
	{
		Widget::MouseDown();
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->MouseDown();
	}
}
void Group::MouseStillDown()
{
	if( Visible() && Enabled() &&
	    ( Contains( Event::Mouse.Location ) || !Corporeal() ) )
	{
		Widget::MouseStillDown();
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->MouseStillDown();
	}
}
void Group::MouseUp()
{
	if( Visible() && Enabled() &&
	    ( Contains( Event::Mouse.Location ) || !Corporeal() ) )
	{
		
		Widget::MouseUp();
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->MouseUp();
	}
}
void Group::MouseMove()
{
	if( Visible() && Enabled() &&
	    ( Contains( Event::Mouse.Location ) || !Corporeal() ) )
	{
		Widget::MouseMove();
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->MouseMove();
	}
}
void Group::DoubleClick()
{
	if( Visible() && Enabled() &&
	    ( Contains( Event::Mouse.Location ) || !Corporeal() ) )
	{
		Widget::DoubleClick();
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->DoubleClick();
	}
}
void Group::ScrollDown()
{
	if( Visible() && Enabled() &&
	    ( Contains( Event::Mouse.Location ) || !Corporeal() ) )
	{
		Widget::ScrollDown();
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->ScrollDown();
	}
}
void Group::ScrollUp()
{
	if( Visible() && Enabled() &&
	    ( Contains( Event::Mouse.Location ) || !Corporeal() ) )
	{
		Widget::ScrollUp();
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->ScrollUp();
	}
}
void Group::KeyDown()
{
	if( Enabled() )
	{
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->KeyDown();
	}
}
bool Group::DoShortcut()
{
	if( Enabled() )
	{
		for( Iterator i = Begin(); i != End(); i++ )
		{
			if( ( *i )->DoShortcut() )
				return true;
		}
	}
	return false;
}

void Group::SetX( int x )
{
	int delta = x - X();
	Widget::SetX( x );
	for( Iterator i = Begin(); i != End(); i++ )
		( *i )->SetX( ( *i )->X() + delta );
}
void Group::SetY( int y )
{				
	int delta = y - Y();
	Widget::SetY( y );
	for( Iterator i = Begin(); i != End(); i++ )
		( *i )->SetY( ( *i )->Y() + delta );
}
void Group::SetRight( int r )
{
	SetX( X() + r - Right() );
}
void Group::SetBottom( int b )
{
	SetX( Y() + b - Bottom() );
}
/*void Group::SetX( int x )
{
	int delta = x - X();
	Widget::SetX( x );
	if( SizeManaged() )
	{
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->SetX( ( *i )->X() + delta );
	}
	else
	{
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->SetX( ( *i )->X() + delta );
	}
}

std::cout << "rt=" << r << std::endl;
	const int delta = r - Right();
	std::cout << "delta=" << delta << std::endl;
	Widget::SetRight( r );
	std::cout << "w1right=" << ( *Begin() )->Right() << std::endl;
	for( Iterator i = Begin(); i != End(); i++ )
	{
		//std::cout << "Ri=" << (*i)->Right() << std::endl;
		( *i )->SetRight( ( *i )->Right() + delta );
		//std::cout << "Rf=" << (*i)->Right() << std::endl;
	}
	//std::cout << std::endl;

void Group::SetY( int y )
{				
	int delta = y - Y();
	Widget::SetY( y );
	if( SizeManaged() )
	{
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->SetY( ( *i )->Y() + delta );
	}
}
void Group::SetRight( int r )
{
	int delta = r - Right();
	Widget::SetRight( r );
	if( SizeManaged() )
	{
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->SetRight( ( *i )->Right() + delta );
	}
}
void Group::SetBottom( int b )
{
	int delta = b - Bottom();
	Widget::SetBottom( b );
	if( SizeManaged() )
	{
		for( Iterator i = Begin(); i != End(); i++ )
			( *i )->SetBottom( ( *i )->Bottom() + delta );
	}
}*/

void Group::SetW( int w )
{
	Widget::SetW( w );
	if( Size() && SizeManaged() )
		Reorganize();
}
void Group::SetH( int h )
{
	Widget::SetH( h );
	if( Size() && SizeManaged() )
		Reorganize();
}

bool Group::Corporeal() const
{
	return _corporeal;
}
void Group::SetCorporeal( bool c )
{
	_corporeal = c;
	Set( 0, 0, 0, 0 );
}

int Group::InternalBorder() const
{
	return _internal_border;
}
void Group::SetInternalBorder( int brd )
{
	_internal_border = brd;
}

bool Group::SizeManaged() const
{
	return _size_managed;
}
void Group::SetSizeManaged( bool m )
{
	_size_managed = m;
}

/*void Group::SetDisplayWidget( Widget* d )
{
	Widget::SetDisplayWidget( d );
	for( unsigned i = 0; i < size(); i++ )
		( *i )->SetDisplayWidget( d );
}*/

void Group::_draw()
{
	if( Corporeal() )
	{
		glColor4f( 0.4, 0.4, 0.4, 1 );
		glRecti( X(), Y(), Right() + 1, Bottom() + 1 );
		glColor4f( 0.84, 0.84, 0.84, 1 );
		glRecti( X() + 1, Y() + 1, Right(), Bottom() );
	}
	DrawChildren();
}

void Group::DrawChildren()
{
	for( Iterator i = Begin(); i != End(); i++ )
		( *i )->Draw();
}

void Group::PushFront( Widget& w )
{
	PushFront( &w );
}
void Group::PushFront( Widget* w )
{
	List< Widget* >::PushFront( w );
	Reorganize();
}

void Group::PushBack( Widget& w )
{
	PushBack( &w );
}
void Group::PushBack( Widget* w )
{
	List< Widget* >::PushBack( w );
	Reorganize();
}

void Group::Erase( Iterator i )
{
	List< Widget* >::Erase( i );
	Reorganize();
}

void Group::Reorganize()
{}

void HorizontalGroup::Reorganize()
{
	int x = X() + Border();
	int width = 0;
	int bottom = Y();
	if( SizeManaged() )
	{
		for( Iterator i = Begin(); i != End(); i++ )
		{
			if( ( *i )->W() > width )
				width = ( *i )->W();
		}
	}
	for( Iterator i = Begin(); i != End(); i++ )
	{
		( *i )->SetX( x );
		( *i )->SetY( Y() + Border() );
		if( ( *i )->Bottom() > bottom )
			bottom = ( *i )->Bottom();
		if( SizeManaged() )
			( *i )->SetW( width );
		x += ( *i )->W() + InternalBorder();
	}
	Math::Rect2D< int >::AnchoredSetRight( Back()->Right() + Border() );
	Math::Rect2D< int >::AnchoredSetBottom( bottom + Border() );
}

void VerticalGroup::Reorganize()
{
	int y = Y() + Border();
	int width = 0;
	int right = X();
	if( SizeManaged() )
	{
		for( Iterator i = Begin(); i != End(); i++ )
		{
			if( ( *i )->W() > width )
				width = ( *i )->W();
		}
	}
	for( Iterator i = Begin(); i != End(); i++ )
	{
		( *i )->SetX( X() + Border() );
		( *i )->SetY( y );
		if( ( *i )->Right() > right )
			right = ( *i )->Right();
		if( SizeManaged() )
			( *i )->SetW( width );
		y += ( *i )->H() + InternalBorder();
	}
	Math::Rect2D< int >::AnchoredSetRight( right + Border() );
	Math::Rect2D< int >::AnchoredSetBottom( Back()->Bottom() + Border() );
}

/*void VerticalGridGroup::_add_child( Widget& w )
{
	w->SetDisplayWidget( DisplayWidget() );
	w->MoveX( X() + Border() );
	w->BecomeChild( this );
	
	if( size() == 0 )
	{
		Nameless().push_back( HorizontalGroup() ); 
		push_back( Nameless().back() );
		at( 0 )->push_back( w );
	}
	else
	{
		if( at( size() - 1 ).
	}
	
	if( size() == 0 )
		w->MoveY( Y() + Border() );
	else
		w->MoveY( at( size() - 1 )->Bottom() + InternalBorder() + 1 );

	if( w->Right() > Right() )
		SetW( w->Right() - X() + Border() + 1 );
	if( w->Bottom() > Bottom() )
		SetH( w->Bottom() - Y() + Border() + 1 );
	
	std::vector< Widget >::push_back( &w );
}*/
