/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "Text.h"
#include "XDisplayGL.h"
#include <GL/gl.h>
#include <GL/glx.h>
#include <sstream>

using namespace SharpConstruct;

GLOut GLOut::glout;

SharpConstruct::Font::Font( std::string n )
{
	/*XFontStruct* font = XLoadQueryFont( Interface::XDisplayGL::GetXDisplay(),
	                                    n.c_str() ); // DIsplay ain't oooened!
	_id = glGenLists( 96 );
	glXUseXFont( font->fid, 32, 96, _id );
	
	_name = n;
	
	_w = font->max_bounds.width;
	_h = font->max_bounds.ascent + font->max_bounds.descent;*/
	_w = 8;
	_h = 13;
}

GLOut::GLOut()
: _alignment( GLFormat::Align::AlignLeft ),
  _current_font( 0 )
{
	_load_fonts();
	
	id = 999;
}

GLOut& GLOut::operator<<( float in )
{
	std::stringstream tmp;
	tmp << in;
	( *this ) << tmp.str();
	return *this;
}

GLOut& SharpConstruct::operator<<( GLOut& out,
                                   std::basic_string< char,
                                                      std::char_traits< char >,
		                                              std::allocator< char > > in )
{
	out._draw_text( in );
	
	return out;
}

const SharpConstruct::Font& GLOut::CurrentFont() const
{
	return _font[ _current_font ];
}

void GLOut::_load_fonts()
{
	_font.push_back( Font( "8x13bold" ) );
}

void GLOut::_draw_text( std::string in )
{
	/*glEnable( GL_TEXTURE_2D );

	_font[ _current_font ].GetTexture().Bind();
	
	Math::Point2D tmp = _location;
	if( _alignment == GLFormat::Align::AlignCenter )
		_location.X -= ( in.length() * _font[ _current_font ].W() ) / 2;
	else if( _alignment == GLFormat::Align::AlignRight )
		_location.X -= ( in.length() * _font[ _current_font ].W() );
	glPushMatrix();
	glTranslatef( _location.X + 0.5, _location.Y - _font[ _current_font ].H() / 2.0 + 0.5, 0 );
	for( unsigned i = 0; i < in.length(); i++ )
	{
		//_draw_letter( in[ i ] );
		glTranslatef( _font[ _current_font ].W(), 0, 0 );
		_location.X += _font[ _current_font ].W();
	}
	glPopMatrix();*/
	///
	
	if( _alignment == GLFormat::Align::AlignCenter )
		_location.SetX( _location.X() - ( in.length() * _font[ _current_font ].W() ) / 2.0f );
	else if( _alignment == GLFormat::Align::AlignRight )
		_location.SetX( _location.X() - ( in.length() * _font[ _current_font ].W() ) );
	
	glColor4f( 0, 0, 0, 1 );
	glPixelStorei( GL_UNPACK_ALIGNMENT, 1 );
	glRasterPos2i( _location.X(), _location.Y() + _font[ _current_font ].H() / 2.0f );

	///	
	if( id == 999 )
	{
		XFontStruct* font = XLoadQueryFont( Interface::XDisplayGL::GetXDisplay(), "8x13bold" );
		id = glGenLists( 96 );
		glXUseXFont( font->fid, 32, 96, id );
		//std::cout << font->max_bounds.width << "x"
		//          << ( font->max_bounds.ascent + font->max_bounds.descent ) << std::endl;
	}
	///
	
	for( unsigned i = 0; i < in.length(); i++ )
	{
		glCallList( in[ i ] - 31 );
		/*glBitmap( _font[ _current_font ].W(), _font[ _current_font ].H(), 0, 0,
		          _font[ _current_font ].W(), 0,
		          &Font1[ ( in[ i ] - 33 ) * 15 ] );*/
		_location.SetX( _location.X() + _font[ _current_font ].W() );
	}
	
	
	/////
	
		/*glEnable( GL_TEXTURE_2D );

	_font[ _current_font ].GetTexture().Bind();

	if( _alignment == GLFormat::Align::AlignCenter )
		_location.X -= ( in.length() * _font[ _current_font ].W() ) / 2;
	else if( _alignment == GLFormat::Align::AlignRight )
		_location.X -= ( in.length() * _font[ _current_font ].W() );
	glPushMatrix();
	glTranslatef( _location.X + 0.5, _location.Y - _font[ _current_font ].H() / 2.0 + 0.5, 0 );
	for( unsigned i = 0; i < in.length(); i++ )
	{
		//_draw_letter( in[ i ] );
		glTranslatef( _font[ _current_font ].W(), 0, 0 );
		_location.X += _font[ _current_font ].W();
	}
	glPopMatrix();
	glDisable( GL_TEXTURE_2D );*/
	///

	//_font[ _current_font ].GetTexture().Bind();

	/*if( _alignment == GLFormat::Align::AlignCenter )
		_location.X -= ( in.length() * _font[ _current_font ].W() ) / 2;
	else if( _alignment == GLFormat::Align::AlignRight )
		_location.X -= ( in.length() * _font[ _current_font ].W() );
	glDisable( GL_BLEND );
	glPixelStorei( GL_UNPACK_ALIGNMENT, 1);
	glRasterPos2i( _location.X, _location.Y );
	glColor4f( 0, 0, 0, 1 );
	//glTranslatef( _location.X + 0.5, _location.Y - _font[ _current_font ].H() / 2.0 + 0.5, 0 );
	for( unsigned i = 0; i < in.length(); i++ )
	{
		glBitmap( 8, 15, 0, 0, 8, 0, &fontX[ in[ i ] - 33 * 15 ] );
		
		//_draw_letter( in[ i ] );
		//glTranslatef( _font[ _current_font ].W(), 0, 0 );
		_location.X += _font[ _current_font ].W();
	}*/
}

void GLOut::_draw_letter( char letter )
{
	if( letter == ' ' )
		return;
	
	const float bx = _font[ _current_font ].W() / 128.0;
	const float by = _font[ _current_font ].H() / 128.0;
	float texX, texY;
	
	int tmp = letter - 33;
	texX = ( tmp % 16 ) * bx;
	texY = ( tmp / 16 ) * by;

	glBegin( GL_QUADS );
	{
		glTexCoord2f( texX, texY );
		glVertex2f( 0, 0 );

		glTexCoord2f( texX + bx, texY );
		glVertex2f( _font[ _current_font ].W(), 0 );
		
		glTexCoord2f( texX + bx, texY + by );
		glVertex2f( _font[ _current_font ].W(), _font[ _current_font ].H() );
		
		glTexCoord2f( texX, texY + by );
		glVertex2f( 0, _font[ _current_font ].H() );
	} glEnd();
}
