/* Copyright 2005 Nicholas Bishop
 * 
 * This file is part of SharpConstruct.
 *
 * SharpConstruct is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * SharpConstruct is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with SharpConstruct; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA */

#include "Toggle.h"
#include "Text.h"
#include <GL/gl.h>

using namespace SharpConstruct::Interface;

void Toggle::_draw()
{
	// Draw border
	if( Contains() && Enabled() )
		glColor4f( 0.3, 0.3, 0.3, 1 );
	else
		glColor4f( 0.5, 0.5, 0.5, 1 );
	glRecti( X(), Y(), Right() + 1, Bottom() + 1 );
	
	// Fill inside
	if( !Contains() || !Enabled() )
		glColor4f( 0.7, 0.7, 0.7, 1 );
	else if( Contains( Event::Mouse.DownLocation ) && Event::Mouse.LeftButtonDown )
		glColor4f( 0.6, 0.6, 0.6, 1 );
	else
		glColor4f( 0.8, 0.8, 0.8, 1 );
	glRecti( X() + 1, Y() + 1, Right(), Bottom() );
	
	// Draw label
	GLOut::glout << GLFormat::Align::Center()
	             << GLFormat::Location( X() + W() / 2, Y() + H() / 2 )
	             << Label();
	// Indicate status
	if( _pressed )
	{
		glColor4f( 0, 0.5, 1, 0.2 );
		glRecti( X(), Y(), Right() + 1, Bottom() + 1 );
	}
	
	// If disabled
	if( !Enabled() )
	{
		glColor4f( 0.5, 0.5, 0.5, 0.7 );
		glRecti( X(), Y(), Right() + 1, Bottom() + 1 );
	}
}
