//
// C++ Interface: passivepopup
//
// Description:
//
//
// Author:  Pieter Pareit <pieter.pareit@scarlet.be>, (C) 2005
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef PASSIVEPOPUP_H
#define PASSIVEPOPUP_H

#include <kpassivepopup.h>

/**
Subclass of KPassivePopup that adds support for different caption and text fonts and is user movable.
 
 
@author Pieter Pareit <pieter.pareit@scarlet.be>
*/
class PassivePopup : public KPassivePopup
{
  Q_OBJECT
public:
  PassivePopup(QWidget *parent = 0, const char *name = 0);
  ~PassivePopup();

  void setCaptionFont( const QFont& );
  void setTextFont( const QFont& );

  virtual void setView( const QString& caption, const QString& text, const QPixmap& icon );

signals:
  void draggingStarted();
  void draggingEnded();
  void draggingEnded( const QPoint& newPosition );

protected:
  virtual void mousePressEvent( QMouseEvent* e );
  virtual void mouseReleaseEvent( QMouseEvent* e );
  virtual void mouseMoveEvent( QMouseEvent* e );

  virtual void positionSelf();

private:
  QFont* m_captionFont;
  QFont* m_textFont;

  bool m_dragging;
  QPoint m_dragOffset;
  int m_oldTimeoutDelay;
};

#endif
